//
//  aclt.java
//  aclt
//
//
package simulazione;
import  alice.tuprolog.*;

public class ACLTLibrary extends Library {

    public ACLTLibrary(){
	  System.out.println("ACLTLibrary loaded.");
    }


    /**
     * library theory
     */
    public String getTheory(){
        return
            //
            // operatori aclt
            //
	//demo		
	"demo(T,TC) :- TC ? inp(rd_all(T,L)), demoL(T,L). \n"+
    "demoL(H,[H|T]). \n"+
	"demoL(T,[_|L]) :- demoL(T,L). \n"+
	//demolast
    "demoLast(T,TC) :- demoLast(T,TC,[]). \n"+
	"demoLast(T,TC,L) :- TC ? inp(rd_all(T,L1)), L2=[H|Tail], diffp(L2,L1,L), demoLastL(T,L2,L2,TC). \n"+
	"demoLastL(T,[T|Tail],L,TC). \n"+
    "demoLastL(T,[_|Tail],L,TC) :- demoLastL(T,Tail,L,TC). \n"+
	"demoLastL(T,[],L,TC) :- demoLast(T,TC,L). \n"+
	//demowait
	"demoWait(T,TC) :- TC ? inp(empty), demoWait(T,TC). \n"+
	"demoWait(T,TC) :- demo(T,TC). \n"+
    //demolastwait
	"demoWaitLast(T,TC) :- TC ? inp(empty), demoWaitLast(T,TC). \n"+
	"demoWaitLast(T,TC) :- demoLast(T,TC). \n"+
	//diff (utility: differenza fra liste)
	"diff(L,La,Lb) :- diffp(L1,La,Lb), diffp(L2,Lb,La), append(L,L1,L2). \n"+
	"diffp([],[],_). \n"+
	"diffp([H|T2],[H|T],Lb) :- not member(H,Lb), diffp(T2,T,Lb). \n"+
	"diffp(L,[H|T],Lb) :- member(H,Lb), diffp(L,T,Lb). \n";
    }

}
