//
//  LogViewer.java
//  LogViewer
//
//
package simulazione;

import java.awt.*;
import javax.swing.*;


public class LogViewer extends JFrame {

	private Font font = new Font("arial", 0, 12);
	private Container ctx;
	private JTextArea ta = new JTextArea();
	
	public LogViewer(String title) {
		
		super(title);
		ctx = this.getContentPane();
		ta.setFont(font);
		ta.setEditable(false);
		ta.append(" * LOG * \n");
		ta.append("\n");
		JScrollPane sp = new JScrollPane(ta);
		sp.createVerticalScrollBar();
		ctx.add(sp);

		setSize(200, 200);
		setVisible(true);
	}


	public void print(String s) {
		ta.append(s+"\n");
		repaint();
	}

	public void paint(Graphics g) {
		super.paint(g);
	}
	
	 public static void main(String args[]) {
		LogViewer LV = new LogViewer("prova");
		LV.print("prova");
	 }

}